#!/bin/sh

# TODO: add patch_identity calling
if [ "$2" = "" ]
then
	serial=000
else
	serial=$2
fi

incdir=inc
mainnoid=boot/main.hex
main=boot/main-id.hex

perl bin/patch_identity.pl $serial < $mainnoid >$main

efuse=$incdir/efuse.hex
hfuse=$incdir/hfuse.hex
lfuse=$incdir/lfuse.hex

Ufv="-U flash:v:$main"
Uev="-U efuse:v:$efuse"
Uhv="-U hfuse:v:$hfuse"
Ulv="-U lfuse:v:$lfuse"
Ufusesv="$Uev $Uhv $Ulv"

Ufw="-U flash:w:$main"
Uew="-U efuse:w:$efuse"
Uhw="-U hfuse:w:$hfuse"
Ulw="-U lfuse:w:$lfuse"
# DO NOT USE in SAME COMMAND, call avrdude SEPARATELY for EACH
Ufusesw="$Uew $Uhw $Ulw"

# makes xfuse.hex file according to parameters if it does not exist
function make_fusehex()
{
	if [ ! -f "$1" ]
	then
		echo ":01000000"$2 > $1
		echo ":00000001FF" >> $1
	fi
}

make_fusehex $lfuse 2FD0
make_fusehex $hfuse C43B
make_fusehex $efuse FF00
# TODO: lock bits

avrdudeargs="-c stk200 -p m128 -v"
# read from a known good (setup) AVR:
#avrdude -c stk200 -p m128 -v -U efuse:r:$efuse -U hfuse:r:$hfuse -U lfuse:r:$lfuse 

# lock bits = 0xef prevents selfdestruction of bootloader

if [ "$1" = "w" ]
then
	echo "writing boot + write fuses after:"
	avrdude $avrdudeargs -e $Ufw 
	# $Ufusesw
fi

if [ "$1" = "f" ]
then
	echo "write fuses only:"
	# avrdude is stupid, so don't write more than 1 fuses in one step
  # avrdude $avrdudeargs -e $Ufusesw
  avrdude $avrdudeargs -e $Uew
  avrdude $avrdudeargs -e $Uhw
  avrdude $avrdudeargs -e $Ulw
  
fi

if [ "$1" = "v" ]
then
	echo "verify fuses and boot:"
	avrdude $avrdudeargs $Ufusesv $Ufv
fi

if [ "$1" = "vf" ]
then
	echo "verify fuses:"
	avrdude $avrdudeargs $Ufusesv 
fi

# verify fuses + write boot:
# avrdude $avrdudeargs -e $Ufusesv $Ufw
