
/*********************************************************\
*  BOOSTCONTROL defines                                   *
*  (C) 2003 [Marcell Gal, cell at x-dsl.hu                *
**********************************************************/
#ifndef BOOSTCONTROL_H
#define BOOSTCONTROL_H

#ifdef BOOSTCONTROL

#include "ve.h"
#include "helpers.h"


/*
moved inside ve.h
struct boost_t {
	uint8_t boostmaxtarget_table[BOOSTCONTROL_LINES * VE_SIZE_RPM];
	uint8_t tpstransfer_table[TPSTRANSFERTABLE_SIZE];
}; 
extern struct boost_t boost;
*/

// called from mainloop:
void boostcontrol_act(void);
void boostcontrol_init(void);

#define BOOSTCONTROL_PWM_PERIOD_8MS ((config.boost_conf & 0xF0)>>4)
#define BOOSTCONTROL_PWM_PERIOD_1MS(config_boost_conf) ((config_boost_conf & 0xF0) >>1 )

#ifndef BOOSTACT_MINTIME
// don't actuate for shorter times than this (*4usec)
#define BOOSTACT_MINTIME	(15)
#endif // BOOSTACT_MINTIME

static inline uint8_t boost_tps_downscale(void)
{
	return interpol8( boost.tpstransfer_table, TPSTRANSFERTABLE_SIZE, engine_tps255() );
}
	/*	
	uint16_t boost_target()
	
	returns the calculated fully-mappable boost-target in 12..13 bits:
	16 * ( config.boost_targetoffs + b[RPM] * t[TPS] / 256)
	
	Note0: currently only TPS and RPM-dependent (gears: later).
	
	8 bits should be enough for engine.boostmax_target: 
	eg. 2kPa unit for max 512kPa boost

	Note1: 
		unit is fully user definable.

	Note2: 
		user chooses with config.boost_targetoffs
	if she wants to reference 
	configured value from 100kPa or 0kPa
	It matters, since it is applied after 
	engine.boostmax_target is downscaled according to the tpstransfer...

	For MAP-target, she probably wants 0kPa, 
	while for boost-target she probably wants 100kPa
	*/
static inline uint16_t boost_target(void)
{
	return ((uint16_t)config.boost_targetoffs << 4) + 
	((uint16_t)(engine.boostmax_target * boost_tps_downscale() ) >> 4);
}

#endif	// BOOSTCONTROL
#endif // BOOSTCONTROL_H

