
#ifndef __V3_HWDEF__
#define __V3_HWDEF__

//TODO 1: New names, many names, ex. INT6, was just inherited from schematic
//TODO 2: put ifndef.. around all IGN_Lxx and INJ_Lxx


// Ignition drivers
// CS_IGN259_PORT
#define IGN_L00 0
#define IGN_L01 1
#define IGN_L02 2
#define IGN_L03 3
#define IGN_L04 4
#define IGN_L05 5
#define IGN_L06 6
#define IGN_L07 7
// the distributor trigger (or EDIS SAW): 
#ifndef IGN_PIN
#define IGN_PIN (IGN_L00)
#endif

// Injection drivers
// PORTA
#define INJ_PORT PORTA
#define INJ_DDR  DDRA

#define INJ_L00 0
#define INJ_L01 1
#define INJ_L02 2
#define INJ_L03 3
#define INJ_L04 4
#define INJ_L05 5
#define INJ_L06 6
#define INJ_L07 7

// 259: stepper etc.
// CS_S259_PORT

#define S259_LCD_RS  0
#define S259_OUT1    1
#define S259_OUT2    2
#define S259_STEP_A  3
#define S259_STEP_B  4
#define S259_STEP_C  5
#define S259_STEP_D  6
#define S259_STEP_EN 7

// 259: misc. drivers
// CS_P259_PORT

// P259_DRIVE_08 used for WOT_OUTPUT in actuators.c
#define P259_DRIVE_08 0
#define P259_DRIVE_09 1
#define P259_LED1     2
#define P259_LED2     3
#define P259_IDL      4
#define P259_FP       5
#define P259_DRIVE_10 6
#define P259_DRIVE_11 7

//////////////////////////////////////////////////////////////77

// PORTB
// take care not to redefine an IO pin!
//#define SS    0
//#define SCK   1
//#define MOSI  2
//#define MISO  3
//#define OC0   4
//#define OC1A  5 // DRIVE_A
#define DRIVE_A 5
//#define OC1B  6 // DRIVE_B
#define DRIVE_B 6
//#define OC2   7

// PORTC
#define LCD_DDIR 0
#define LCD_EN   1
#define CS_KNOCK 2
#define KNOCK_INTEGRATE 3
#define LBUS_4   4
#define LBUS_5   5
#define LBUS_6   6 
#define LBUS_7   7

#define CS_KNOCK_PORT PORTC
#define CS_KNOCK_INTEGRATE_PORT CS_KNOCK_PORT

// PORTD
#define SCL      0	// default LAUNCH switch
#define SDA      1 // default ALS on/off switch pin
//#define RX1      2
//#define TX1      3
//#define IC1      4
#define CS_CAN   5
//#define CS_S259  6
//#define CS_P259  7

// PORTE
//#define RXD      0
//#define TXD      1
#define KB_DATA  2   // ps2 keyboard
//#define OC3A     3
//#define OC3B     4
//#define OC3C     5
#define CLOCK    6   // ps2 keyboard
//#define IC3      7

// PORTG
#define HEAT1     0
#define HEAT2     1
//#define CS_IGN259 2
#define CS_FLASH  3
#define CS_MCP    4

#define CS_MCP_PORT PORTG

// PORTF
// ADC, see definitions in adc.h

// LEDs are not on direct AVRport in v3, but ledstate variable is there
#define LED_STATUS  3
#define LED_MISC    4
#define LED_ACCEL   5
#define LED_WARMUP  6
#define LED_SQUIRT  7

// for the STIM output (only when user selects from menu, so why not?)
#define LEDPORT PORTA

// Default ALS activator switch configuration (you can override these in my_make)
#ifndef ALS_SWITCH_PORT
#define ALS_SWITCH_PORT PORTD
#define ALS_SWITCH_DDR  DDRD
#define ALS_SWITCH_IN   PIND
#define ALS_SWITCH_PIN  SDA
#endif

// Default LAUNCH control activator switch configuration (you can override these in my_make)
#ifndef LAUNCH_SWITCH_PORT
#define LAUNCH_SWITCH_PORT PORTD
#define LAUNCH_SWITCH_DDR  DDRD
#define LAUNCH_SWITCH_IN   PIND
#define LAUNCH_SWITCH_PIN  SCL
#endif

#ifndef MCP3208_EGT1
// 4 is valid for v3.2. v3.0-v3.1 users will add MY_CONF += -D MCP3208_EGT1=5 to my_make
#define MCP3208_EGT1 4
#endif

#endif	// __V3_HWDEF__
