/*********************************************************\
*  AVR MegaSquirt - 2003                                  *
*  (C) 2003 [Marcell Gal cell at x-dsl.hu]                *
***********************************************************
*  -- History --                                          *
\*********************************************************/


#ifndef __RINGBUF_H__
#define __RINGBUF_H__

#include "comm.h"
#include "menu.h"
#include <inttypes.h>

#define RINGBUFLEN	32

struct ringbuf_t {
  uint8_t hidx;	// head index
  uint8_t tidx;	// tail index
  uint8_t cnt;
  uint8_t buf[RINGBUFLEN];
};

extern struct ringbuf_t comm_recbuf, comm_sndbuf;

void ringbuf_init(struct ringbuf_t *);
/* FIFO functions named a'la perl style: push appends, shift gets first */
void ringbuf_push(struct ringbuf_t *, uint8_t);
uint8_t ringbuf_push_n(struct ringbuf_t *r, uint8_t *val, uint8_t n);

/* called from userspace: calls menu_char() if appropriate */
void ringbuf_shift_proc(struct menu_t *, struct ringbuf_t *);


uint16_t ringbuf_shift(struct ringbuf_t *);
void ringbuf_fill(struct ringbuf_t *sndbuf, struct menu_t *menu); /* process cmdqueue until empty or ringbuf full */

#endif
