#ifndef __SLCAN_H_
#define __SLCAN_H_

#include <inttypes.h>

/* HDLC special characters */
#define HDLC_END         0x7E            /* indicates end of frame; also sent at the beginning to flush any trash that accumulated in the receiver */
#define HDLC_ESC         0x7D            /* indicates byte stuffing      */
#define HDLC_ESCAPE(x)   ((x)^0x20)
#define HDLC_UNESCAPE(x) ((x)^0x20)

#define CRC_INITIAL	0xFFFF

#define CANID_SIPR	29


// TODO: make these dynamic, based on configured firmware node address
static inline uint8_t node_address_high( void )
{
		return 'A';
}
static inline uint8_t node_address_low( void )
{
		return 'd';
}

void slcan_process_inc( uint8_t c );
uint8_t srl_slcan_packet( uint8_t i );

#endif


