/*********************************************************\
*  AVR MegaSquirt - 2003                                  *
*  (C) 2003 [Michael Kristensen, mik@caffrey.dk]          *
***********************************************************
*  -- History --                                          *
*    release 0.1 - 06-03-2003                             *
*            http://caffrey.dk/megasquirt                 *
*    initial Motorola version by Bowling & Grippo (2002)  *
*            http://www.bgsoflex.com/megasquirt.html      *
\*********************************************************/


#ifndef __STORAGE_H__
#define __STORAGE_H__

#include <inttypes.h>

#define SEEPROM __attribute__((section(".eeprom")))


extern struct config_t config;
extern struct ve_t ve;


enum {BEGIN_STORING, STORE_CONFIG, STORE_VE, STORE_IGN, STORE_HWMAP, STORE_BOOST, DONE};
enum { TABLE_C, TABLE_VE, TABLE_LA, TABLE_IGN};


/* flags for the storage operation on the eeprom. 
 * the high 4 bits are reserved for the configid */
volatile uint8_t eeprom_flags;

#define busy 0
#define start 1
#define active 2
// bit 4..7 reserved



uint8_t state;
uint8_t *p_eeprom;
uint8_t *p_sram;
uint16_t length;
uint16_t offset;


void init_storage(void);
uint8_t save_variables(uint8_t configid);
void store_control(void);
uint8_t store_setup(void);
uint8_t store_bytes(void);
void load_variables(uint8_t configid);
void get_undovalue(uint8_t table, uint8_t idx);

#endif
